import { ACSConversation } from "../core/messaging/ACSClient";
import ScenarioMarker from "../telemetry/ScenarioMarker";
/**
 * On demand command to start polling messages from `chatSDK.onNewMessage()` subscribers when polling was previously halted.
 *
 * @param isInitialized Whether Chat SDK has been initialized
 * @param scenarioMarker Scenario Marker object
 * @param liveChatVersion Live Chat version
 * @param requestId Request Id
 * @param chatId Chat Id
 * @param conversation ACS Conversation object
 */
declare const startPolling: (isInitialized: boolean, scenarioMarker: ScenarioMarker, liveChatVersion: number, requestId: string, chatId: string, conversation: ACSConversation | null) => Promise<void>;
export default startPolling;
