import { AWTEventData, AWTLogConfiguration } from '../external/aria/webjs/AriaSDK';
import ScenarioType from '../telemetry/ScenarioType';
interface CDNPackagesInfo {
    IC3Client?: string;
    IC3Adapter?: string;
    ACSAdapter?: string;
    DirectLine?: string;
    SpoolSDK?: string;
    VoiceVideoCalling?: string;
}
declare class AriaTelemetry {
    private static _logger;
    private static _debug;
    private static _CDNPackagesInfo;
    private static _disable;
    private static _key;
    private static _collectorUri;
    private static _configuration;
    static initialize(key: string, configuration?: AWTLogConfiguration): void;
    static setDebug(flag: boolean): void;
    static disable(): void;
    static setCollectorUri(collectorUri: string): void;
    static setCDNPackages(packages: CDNPackagesInfo): void;
    static info(properties: AWTEventData["properties"], scenarioType?: ScenarioType): void;
    static debug(properties: AWTEventData["properties"], scenarioType?: ScenarioType): void;
    static warn(properties: AWTEventData["properties"], scenarioType?: ScenarioType): void;
    static error(properties: AWTEventData["properties"], scenarioType?: ScenarioType): void;
    static log(properties: AWTEventData["properties"], scenarioType?: ScenarioType): void;
    private static get logger();
    private static populateBaseProperties;
    private static fillMobilePlatformData;
    private static fillWebPlatformData;
    private static populateIC3ClientBaseProperties;
    private static populateOCSDKBaseProperties;
    private static populateACSClientBaseProperties;
    private static populateACSAdapterBaseProperties;
    private static populateCallingSDKBaseProperties;
    private static populateAMSClientBaseProperties;
}
export default AriaTelemetry;
