import { AWTEventData } from "../external/aria/webjs/AriaSDK";
import AriaTelemetry from "./AriaTelemetry";
import OmnichannelConfig from "../core/OmnichannelConfig";
import ScenarioType from "./ScenarioType";
declare class ScenarioMarker {
    private omnichannelConfig;
    private debug;
    private runtimeId;
    private telemetryEvents;
    private telemetry;
    private scenarioType;
    constructor(omnichannelConfig: OmnichannelConfig);
    setDebug(flag: boolean): void;
    setScenarioType(scenarioType: ScenarioType): void;
    setRuntimeId(runtimeId: string): void;
    useTelemetry(telemetry: typeof AriaTelemetry): void;
    startScenario(event: string, additionalProperties?: AWTEventData["properties"]): void;
    singleRecord(event: string, additionalProperties: {}): void;
    failScenario(event: string, additionalProperties?: AWTEventData["properties"]): void;
    completeScenario(event: string, additionalProperties?: AWTEventData["properties"]): void;
}
export default ScenarioMarker;
