import { MessageType } from "./types/MessageType";
import { OmnichannelMessagePrinter } from "./OmnichannelMessagePrinter";
import { PollingMessagePrinter } from "./PollingMessagePrinter";
import { PrintableMessage } from "./types/PrintableMessageType";
import { WebSocketMessagePrinter } from "./WebsocketMessagePrinter";
export declare enum PrinterType {
    Polling = "Polling",
    WebSocket = "WebSocket",
    Omnichannel = "Rest"
}
export declare class MessagePrinterFactory {
    static getPrinter(printerType: PrinterType): typeof OmnichannelMessagePrinter | typeof PollingMessagePrinter | typeof WebSocketMessagePrinter;
    static printifyMessage: (message: MessageType, printerType: PrinterType) => PrintableMessage;
}
