"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PollingMessagePrinter = void 0;
var SupportedAdaptiveCards_1 = require("./interfaces/SupportedAdaptiveCards");
var utilities_1 = require("../utilities");
var PollingMessagePrinter = /** @class */ (function () {
    function PollingMessagePrinter() {
    }
    PollingMessagePrinter.printify = function (message) {
        var _a, _b, _c, _d;
        var result = {};
        if (message) {
            result.id = message.id;
            result.tags = message && ((_a = message.metadata) === null || _a === void 0 ? void 0 : _a.tags) ? message.metadata.tags.replace(/"/g, "").split(",").filter(function (tag) { return tag.length > 0; }) : [];
            result.card = Object.values(SupportedAdaptiveCards_1.SupportedAdaptiveCards).some(function (type) { var _a, _b; return (_b = (_a = message === null || message === void 0 ? void 0 : message.content) === null || _a === void 0 ? void 0 : _a.message) === null || _b === void 0 ? void 0 : _b.includes(type); });
            result.bot = ((_b = result.tags) === null || _b === void 0 ? void 0 : _b.find(function (tag) { return tag === 'public'; })) ? false : true;
            if (!result.card && ((_c = message === null || message === void 0 ? void 0 : message.content) === null || _c === void 0 ? void 0 : _c.message)) {
                result.content = (0, utilities_1.messageContentMetadata)((_d = message.content) === null || _d === void 0 ? void 0 : _d.message);
            }
            result.created = message.createdOn;
        }
        return result;
    };
    return PollingMessagePrinter;
}());
exports.PollingMessagePrinter = PollingMessagePrinter;
//# sourceMappingURL=PollingMessagePrinter.js.map